com.saxonica.config

## Class JavaExtensionLibrary

- java.lang.Object
- - com.saxonica.config.JavaExtensionLibrary

- All Implemented Interfaces:
    Serializable, FunctionLibrary

      public class JavaExtensionLibrary
      extends Object
      implements FunctionLibrary

  The JavaExtensionLibrary is a FunctionLibrary that binds XPath function calls to calls on Java methods (or constructors, or fields). It performs a mapping from the namespace URI of the function to the Java class (the mapping is partly table driven and partly algorithmic), and maps the local name of the function to the Java method, constructor, or field within the class. If the Java methods are polymorphic, then it tries to select the appropriate method based on the static types of the supplied arguments. Binding is done entirely at XPath compilation time.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `JavaExtensionLibrary(ProfessionalConfiguration config)` Construct a JavaExtensionLibrary and establish the default uri->class mappings.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected int` | `atomicConversionPreference(int primitiveType, Class required)` Get the conversion preference from an XPath primitive atomic type to a Java class
    `Expression` | `bind(StructuredQName functionName, int arity, Expression[] staticArgs, StaticContext env, Container container)` Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
    `FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
    `void` | `declareJavaClass(String uri, Class theClass)` Declare a mapping from a specific namespace URI to a Java class
    `JavaExtensionFunctionFactory` | `getExtensionFunctionFactory()` Get the ExtensionFunctionFactory used by this extension library.
    `protected Class` | `getExternalJavaClass(String uri, boolean debug)` Get an external Java class corresponding to a given namespace URI, if there is one.
    `FunctionItem` | `getFunctionItem(StructuredQName functionName, int arity, StaticContext staticContext)` Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.
    `boolean` | `isAvailable(StructuredQName functionName, int arity)` Test whether a function with a given name and arity is available
    `boolean` | `isStrictJavaUriFormat()` Ask whether only the strict "java:" URI format is to be recognized.
    `void` | `setExtensionFunctionFactory(JavaExtensionFunctionFactory factory)` Set the ExtensionFunctionFactory to be used by this extension library.
    `void` | `setStrictJavaUriFormat(boolean strict)` Say that only the strict "java:" URI format is to be recognized.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### JavaExtensionLibrary

          public JavaExtensionLibrary(ProfessionalConfiguration config)

      Construct a JavaExtensionLibrary and establish the default uri->class mappings.
      Parameters:
        `config` - The Saxon configuration

  - ### Method Detail

    - #### setExtensionFunctionFactory

          public void setExtensionFunctionFactory(JavaExtensionFunctionFactory factory)

      Set the ExtensionFunctionFactory to be used by this extension library.
      Parameters:
        `factory` - This must be an instanceof JavaExtensionFunctionFactory

    - #### getExtensionFunctionFactory

          public JavaExtensionFunctionFactory getExtensionFunctionFactory()

      Get the ExtensionFunctionFactory used by this extension library.
      Returns:
        the factory, which will always be an instanceof JavaExtensionFunctionFactory

    - #### isStrictJavaUriFormat

          public boolean isStrictJavaUriFormat()

      Ask whether only the strict "java:" URI format is to be recognized. The default is "true": the value false can be set for backwards compatibility with releases before Saxon 9.2
      Returns:
        true if only the strict format is recognized

    - #### setStrictJavaUriFormat

          public void setStrictJavaUriFormat(boolean strict)

      Say that only the strict "java:" URI format is to be recognized. The default is "true": the value false can be set for backwards compatibility with releases before Saxon 9.2
      Parameters:
        `strict` - true if only the strict format is recognized

    - #### declareJavaClass

          public void declareJavaClass(String uri,
                              Class theClass)

      Declare a mapping from a specific namespace URI to a Java class
      Parameters:
        `uri` - the namespace URI of the function name
        `theClass` - the Java class that implements the functions in this namespace

    - #### getFunctionItem

          public FunctionItem getFunctionItem(StructuredQName functionName,
                                     int arity,
                                     StaticContext staticContext)
                                       throws XPathException

      Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.

      This supports the function-lookup() function in XPath 3.0.

      Specified by:
        `getFunctionItem` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
        `arity` - The number of arguments.
        `staticContext` - the static context to be used by the function, in the event that it is a system function with dependencies on the static context
      Returns:
        if a function of this name and arity is available for calling, then a corresponding function item; or null if the function does not exist
      Throws:
        `XPathException` - in the event of certain errors, for example attempting to get a function that is private

    - #### isAvailable

          public boolean isAvailable(StructuredQName functionName,
                            int arity)

      Test whether a function with a given name and arity is available

      This supports the function-available() function in XSLT.

      Specified by:
        `isAvailable` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
        `arity` - The number of arguments.
      Returns:
        true if a function of this name and arity is available for calling

    - #### bind

          public Expression bind(StructuredQName functionName,
                        int arity,
                        Expression[] staticArgs,
                        StaticContext env,
                        Container container)
                          throws XPathException

      Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.
      Specified by:
        `bind` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
        `arity` -
        `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality()) may be used as part of the binding algorithm.
        `env` - the static context
        `container` -
      Returns:
        An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name, arity, or signature.
      Throws:
        `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function.

    - #### atomicConversionPreference

          protected int atomicConversionPreference(int primitiveType,
                                       Class required)

      Get the conversion preference from an XPath primitive atomic type to a Java class
      Parameters:
        `primitiveType` - integer code identifying the XPath primitive type, for example `StandardNames.XS_STRING` or `StandardNames.XS_STRING`
        `required` - The Java Class named in the method signature
      Returns:
        an integer indicating the relative preference for converting this primitive type to this Java class. A high number indicates a low preference. All values are in the range 50 to 100. For example, the conversion of an XPath String to `StringValue` is 50, while XPath String to `String` is 51. The value -1 indicates that the conversion is not allowed.

    - #### getExternalJavaClass

          protected Class getExternalJavaClass(String uri,
                                   boolean debug)

      Get an external Java class corresponding to a given namespace URI, if there is one. The method is protected so it can be overridden in a user-defined subclass.
      Parameters:
        `uri` - The namespace URI corresponding to the prefix used in the function call.
      Returns:
        the Java class name if a suitable class exists, otherwise return null.

    - #### copy

          public FunctionLibrary copy()

      This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
      Specified by:
        `copy` in interface `FunctionLibrary`
      Returns:
        a copy of this function library. This must be an instance of the original class.

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.